
//  FileToNumbers.kt  (c) Kari Laitinen

//  http://www.naturalprogramming.com

//  2023-06-15  File created.


import java.io.*

fun main( command_line_parameters : Array<String> )
{
   if ( command_line_parameters.size  ==  1 )
   {
      try
      {
         val file_to_read = FileInputStream( command_line_parameters[ 0 ] )

         val bytes_from_file = ByteArray( 16 )

         var file_processing_ready = false

         while ( file_processing_ready == false )
         {
            val number_of_bytes_read = file_to_read.read( bytes_from_file )
         
            if ( number_of_bytes_read > 0 )
            {
               val line_of_bytes  =  StringBuilder()
               val bytes_as_characters  =  StringBuilder ()

               var byte_index  =  0
               
               while ( byte_index  <  number_of_bytes_read )
               {
                  line_of_bytes.append(
                    String.format( " %02X", bytes_from_file[ byte_index ] ) )

                  val byte_as_character  = bytes_from_file[ byte_index ].toInt().toChar()

                  if ( byte_as_character  >=  ' ' )
                  {
                     bytes_as_characters.append( byte_as_character )
                  }
                  else
                  {
                     bytes_as_characters.append( ' ' )
                  }
                  
                  byte_index ++
               }

               print( String.format( "\n%-48s  %s", line_of_bytes, bytes_as_characters ) )
            }
            else
            {
               file_processing_ready = true
            }
         }

         file_to_read.close()
      }
      catch ( caught_file_not_found_exception : FileNotFoundException )
      {
         print( "\n Cannot open file "
                        +  command_line_parameters[ 0 ] )
      }
      catch ( caught_io_exception : IOException )
      {
         print( "\n Error while processing file "
                        +  command_line_parameters[ 0 ] )
      }
   }
   else
   {
      print( "\n You have to command this program so that"
          +  "\n you give the file name from command line \n")
   }
}







